void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





static inline UINT __ANAOUT_1_MOVE__UINT__UINT1(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE6_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE6_ENO,,__TMP_ENO);
  return __res;
}

static inline UINT __ANAOUT_1_MOVE__UINT__UINT2(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE11_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE11_ENO,,__TMP_ENO);
  return __res;
}

static inline UINT __ANAOUT_1_MOVE__UINT__UINT3(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE16_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE16_ENO,,__TMP_ENO);
  return __res;
}

static inline UINT __ANAOUT_1_MOVE__UINT__UINT4(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE21_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE21_ENO,,__TMP_ENO);
  return __res;
}

static inline UINT __ANAOUT_1_MOVE__UINT__UINT5(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE28_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE28_ENO,,__TMP_ENO);
  return __res;
}

static inline UINT __ANAOUT_1_MOVE__UINT__UINT6(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE33_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE33_ENO,,__TMP_ENO);
  return __res;
}

static inline UINT __ANAOUT_1_MOVE__UINT__UINT7(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE37_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE37_ENO,,__TMP_ENO);
  return __res;
}

static inline UINT __ANAOUT_1_MOVE__UINT__UINT8(BOOL EN,
  UINT IN,
  ANAOUT_1 *data__)
{
  UINT __res;
  BOOL __TMP_ENO = __GET_VAR(data__->_TMP_MOVE41_ENO,);
  __res = MOVE__UINT__UINT(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->_TMP_MOVE41_ENO,,__TMP_ENO);
  return __res;
}

void ANAOUT_1_init__(ANAOUT_1 *data__, BOOL retain) {
  __INIT_LOCATED(BOOL,__IX0_0,data__->CH0LEV1,retain)
  __INIT_LOCATED_VALUE(data__->CH0LEV1,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_1,data__->CH0LEV2,retain)
  __INIT_LOCATED_VALUE(data__->CH0LEV2,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_2,data__->CH0LEV3,retain)
  __INIT_LOCATED_VALUE(data__->CH0LEV3,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_3,data__->CH1LEV1,retain)
  __INIT_LOCATED_VALUE(data__->CH1LEV1,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_4,data__->CH1LEV2,retain)
  __INIT_LOCATED_VALUE(data__->CH1LEV2,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_5,data__->CH1LEV3,retain)
  __INIT_LOCATED_VALUE(data__->CH1LEV3,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(UINT,__QW0,data__->ANAOUT0,retain)
  __INIT_LOCATED_VALUE(data__->ANAOUT0,0)
  __INIT_LOCATED(UINT,__QW1,data__->ANAOUT1,retain)
  __INIT_LOCATED_VALUE(data__->ANAOUT1,0)
  __INIT_VAR(data__->_TMP_MOVE6_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE6_OUT,0,retain)
  __INIT_VAR(data__->_TMP_MOVE11_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE11_OUT,0,retain)
  __INIT_VAR(data__->_TMP_MOVE16_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE16_OUT,0,retain)
  __INIT_VAR(data__->_TMP_MOVE21_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE21_OUT,0,retain)
  __INIT_VAR(data__->_TMP_MOVE28_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE28_OUT,0,retain)
  __INIT_VAR(data__->_TMP_MOVE33_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE33_OUT,0,retain)
  __INIT_VAR(data__->_TMP_MOVE37_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE37_OUT,0,retain)
  __INIT_VAR(data__->_TMP_MOVE41_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_MOVE41_OUT,0,retain)
}

// Code part
void ANAOUT_1_body__(ANAOUT_1 *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->,_TMP_MOVE6_OUT,,__ANAOUT_1_MOVE__UINT__UINT1(
    (BOOL)((!(__GET_LOCATED(data__->CH0LEV3,)) && !(__GET_LOCATED(data__->CH0LEV2,))) && !(__GET_LOCATED(data__->CH0LEV1,))),
    (UINT)__UINT_LITERAL(0),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE6_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT0,,__GET_VAR(data__->_TMP_MOVE6_OUT,));
  };
  __SET_VAR(data__->,_TMP_MOVE11_OUT,,__ANAOUT_1_MOVE__UINT__UINT2(
    (BOOL)__GET_LOCATED(data__->CH0LEV1,),
    (UINT)__UINT_LITERAL(0x9000),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE11_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT0,,__GET_VAR(data__->_TMP_MOVE11_OUT,));
  };
  __SET_VAR(data__->,_TMP_MOVE16_OUT,,__ANAOUT_1_MOVE__UINT__UINT3(
    (BOOL)__GET_LOCATED(data__->CH0LEV2,),
    (UINT)__UINT_LITERAL(0xA000),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE16_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT0,,__GET_VAR(data__->_TMP_MOVE16_OUT,));
  };
  __SET_VAR(data__->,_TMP_MOVE21_OUT,,__ANAOUT_1_MOVE__UINT__UINT4(
    (BOOL)__GET_LOCATED(data__->CH0LEV3,),
    (UINT)__UINT_LITERAL(0xC000),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE21_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT0,,__GET_VAR(data__->_TMP_MOVE21_OUT,));
  };
  __SET_VAR(data__->,_TMP_MOVE28_OUT,,__ANAOUT_1_MOVE__UINT__UINT5(
    (BOOL)((!(__GET_LOCATED(data__->CH1LEV3,)) && !(__GET_LOCATED(data__->CH1LEV2,))) && !(__GET_LOCATED(data__->CH1LEV1,))),
    (UINT)__UINT_LITERAL(0),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE28_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT1,,__GET_VAR(data__->_TMP_MOVE28_OUT,));
  };
  __SET_VAR(data__->,_TMP_MOVE33_OUT,,__ANAOUT_1_MOVE__UINT__UINT6(
    (BOOL)__GET_LOCATED(data__->CH1LEV1,),
    (UINT)__UINT_LITERAL(0x8000),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE33_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT1,,__GET_VAR(data__->_TMP_MOVE33_OUT,));
  };
  __SET_VAR(data__->,_TMP_MOVE37_OUT,,__ANAOUT_1_MOVE__UINT__UINT7(
    (BOOL)__GET_LOCATED(data__->CH1LEV2,),
    (UINT)__UINT_LITERAL(0xA000),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE37_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT1,,__GET_VAR(data__->_TMP_MOVE37_OUT,));
  };
  __SET_VAR(data__->,_TMP_MOVE41_OUT,,__ANAOUT_1_MOVE__UINT__UINT8(
    (BOOL)__GET_LOCATED(data__->CH1LEV3,),
    (UINT)__UINT_LITERAL(0xFFFF),
    data__));
  if (__GET_VAR(data__->_TMP_MOVE41_ENO,)) {
    __SET_LOCATED(data__->,ANAOUT1,,__GET_VAR(data__->_TMP_MOVE41_OUT,));
  };

  goto __end;

__end:
  return;
} // ANAOUT_1_body__() 





